#ifndef _HAL_GPIO_DEF_H_
#define _HAL_GPIO_DEF_H_

#ifndef PORT_SHIFT
#define PORT_SHIFT          5
#endif
#ifndef PORT_PIN
#define PORT_PIN(p,n,conf)  (((p)<<PORT_SHIFT) | (n) | (conf))
#define PORT_CONF_MASK      0xffc00000
#endif

#define PORT_CONF_DIR_MASK  0x00400000
#define PORT_CONF_DIR_IN    (0x00000000 | PORT_CONF_SET_DIR)
#define PORT_CONF_DIR_OUT   (0x00400000 | PORT_CONF_SET_DIR)

#define PORT_CONF_INIT_MASK 0x00800000
#define PORT_CONF_INIT_LOW  0x00000000
#define PORT_CONF_INIT_HIGH 0x00800000

#define PORT_CONF_OD_MASK   0x01000000
#define PORT_CONF_OD_OFF    0x00000000
#define PORT_CONF_OD_ON     0x01000000

#define PORT_CONF_MODE_MASK 0x0e000000
#define PORT_CONF_MODE_NORM 0x00000000
#define PORT_CONF_MODE_PD   0x02000000
#define PORT_CONF_MODE_PU   0x04000000
#define PORT_CONF_MODE_REP  0x06000000
#define PORT_CONF_MODE_ADC  0x08000000

#define PORT_CONF_SET_DIR   0x10000000

#define PORT_CONF_FNC_MASK  0xe0000000
#define PORT_CONF_FNC_GPIO  0x00000000
#define PORT_CONF_FNC_0     0x00000000
#define PORT_CONF_FNC_1     0x20000000
#define PORT_CONF_FNC_2     0x40000000
#define PORT_CONF_FNC_3     0x60000000
#define PORT_CONF_FNC_4     0x80000000
#define PORT_CONF_FNC_5     0xa0000000
#define PORT_CONF_FNC_6     0xc0000000
#define PORT_CONF_FNC_7     0xe0000000

#define PORT_CONF_GPIO_IN   (PORT_CONF_DIR_IN | PORT_CONF_FNC_GPIO | PORT_CONF_MODE_NORM)
#define PORT_CONF_GPIO_IN_PU (PORT_CONF_DIR_IN | PORT_CONF_FNC_GPIO | PORT_CONF_MODE_PU)
#define PORT_CONF_GPIO_IN_PD (PORT_CONF_DIR_IN | PORT_CONF_FNC_GPIO | PORT_CONF_MODE_PD)
#define PORT_CONF_GPIO_IN_REP (PORT_CONF_DIR_IN | PORT_CONF_FNC_GPIO | PORT_CONF_MODE_REP)

#define PORT_CONF_GPIO_OUT_LO (PORT_CONF_DIR_OUT | PORT_CONF_FNC_GPIO | PORT_CONF_INIT_LOW)
#define PORT_CONF_GPIO_OUT_HI (PORT_CONF_DIR_OUT | PORT_CONF_FNC_GPIO | PORT_CONF_INIT_HIGH)
#define PORT_CONF_GPIO_OUT_LO_OD (PORT_CONF_GPIO_OUT_LO | PORT_CONF_OD_ON)
#define PORT_CONF_GPIO_OUT_HI_OD (PORT_CONF_GPIO_OUT_LO | PORT_CONF_OD_ON)

#define PORT_CONF_OUT_LO_NORM (PORT_CONF_DIR_OUT | PORT_CONF_INIT_LOW | PORT_CONF_MODE_NORM)
#define PORT_CONF_OUT_HI_NORM (PORT_CONF_DIR_OUT | PORT_CONF_INIT_HIGH | PORT_CONF_MODE_NORM)
#define PORT_CONF_IN_PU       (PORT_CONF_DIR_IN | PORT_CONF_MODE_PU)
#define PORT_CONF_IN_REP      (PORT_CONF_DIR_IN | PORT_CONF_MODE_REP)


#endif /*_HAL_GPIO_H_*/
